package edu.travel.commodity.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import edu.travel.commodity.entity.ShopCategory;
import com.baomidou.mybatisplus.extension.service.IService;
import edu.travel.remote.dto.BaseDto;
import edu.travel.remote.dto.ShopCategoryDto;
import edu.travel.remote.dto.ShopTypeDto;
import edu.travel.remote.vo.ShopCategoryVo;
import edu.travel.remote.vo.ShopTypeVo;
import edu.travel.rpc.RPCBaseResponse;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;
import java.util.concurrent.ExecutionException;

public interface ShopCategoryService extends IService<ShopCategory>{

    RPCBaseResponse<Page<ShopCategoryVo>> getCategoryPage(ShopCategoryDto shopCategoryDto);

    List<ShopTypeVo> getShopType(ShopTypeDto param) throws ExecutionException;

    List<ShopTypeVo> getLevelToShopType(BaseDto param) throws ExecutionException;

    RPCBaseResponse<String> uploadIcon(MultipartFile file);
}
